/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2018 Verchenko Andrey <verchenkoag@gmail.com>
 * Copyright 2018 Sergej Kiselev <bilance@bilance.lv>
*/
 
#include "hmg.ch"
#include "TSBrowse.ch"

STATIC aStaticBrwBackColor, nStaticReturn

////////////////////////////////////////////////////////////////////////////////////
FUNCTION TsbCreate( oBrw, aDatos, nFSize, aBackColor )
   LOCAL aRect := GetDeskTopArea()   //   { left, top, right, bottom }
   LOCAL nDeskTopWidth  := aRect[ 3 ] - aRect[ 1 ] - GetBorderWidth()
   LOCAL nDeskTopHeight := aRect[ 4 ] - aRect[ 2 ] - GetBorderHeight()
   LOCAL aArray, aFontHF, aHead, aWSize, aFoot, aPict, aAlign, aName
   LOCAL nI, oCol, nSlr, nHCell, nWBrw, aDim

   nSlr := IIF(oBrw:lSelector,1,0) //   Selector

   aArray   := aDatos[ 1 ]         //  
   aHead    := aDatos[ 2 ]         //   
   aWSize   := aDatos[ 3 ]         //    
   aFoot    := aDatos[ 4 ]         //   
   aPict    := aDatos[ 5 ]         //     
   aAlign   := aDatos[ 6 ]         //   
   aName    := aDatos[ 7 ]         //       
   aFontHF  := aDatos[ 8 ]         //   header, footer

   aStaticBrwBackColor := aBackColor

   nWBrw := oBrw:nRight - oBrw:nLeft //  

   //aWSize := { 60, nWBrw - 90 - GetVScrollBarWidth() - 2 }  //     
   nHCell := nFSize*2

   WITH OBJECT oBrw  // oBrw  \

      :Cargo := 3         //    / 

      //    
      :SetArrayTo(aArray, aFontHF, aHead, aWSize, aFoot, aPict, aAlign, aName)

      //      20 
      :AddSuperHead( 1, :nColCount() + nSlr, "Super_Header_Table",,, .F.,,, .F., .F., .F., 1, )
      :aSuperhead[ 1, 3 ] := "List of files"
      :nHeightSuper := 20

      :lNoHScroll   := .T.         //    
      :nWheelLines  := 1           //   
      :nClrLine     := COLOR_GRID  //     
      :lNoChangeOrd := .T.         //      
      :nColOrder    := 0           //     
      :lNoGrayBar   := .F.         //     

      :nHeightCell  := nHCell      //    
      :nHeightHead  := nFSize*2    //      
      :nHeightFoot  := nFSize*1.3  //      
      :lFooting     := .T.         //  
      :lDrawFooters := .T.         //   

      :nLineStyle   := LINES_ALL   // LINES_NONE LINES_ALL LINES_VERT LINES_HORZ LINES_3D LINES_DOTTED
                                   //    

      For nI := 1 To :nColCount()
         oCol            := :aColumns[ nI ]
         If oCol:cName == "Name_1"
            oCol:nAlign  := DT_CENTER  //   "Name_1"
         EndIf
         // -------------- Fixed cursor ,   ---------
         :aColumns[nI]:lFixLite := TRUE
         oCol:cFooting := ""
      Next
      :aColumns[2]:cFooting := "F9-test key  "

      //   
      TsbColor( oBrw, This.Backcolor, aStaticBrwBackColor, , )  

   END WITH  // oBrw  

   // ---------     ESC  TSBROWSE  ------------------
   oBrw:bOnEscape := {|| DoMethod(oBrw:cParentWnd, "Release") }  //  

   //      
   oBrw:bLDblClick := {|p1,p2,p3,ob| p1:=p2:=p3, ob:PostMsg( WM_KEYDOWN, VK_RETURN, 0 ) } 

   //      ENTER
   //oBrw:UserKeys(VK_RETURN, {|ob| nStaticReturn := ob:nAt, DoMethod(ob:cParentWnd, "Release") }) 
   oBrw:UserKeys(VK_RETURN, {|ob| nStaticReturn := ob:nAt                         ,;
                                  aDim := FormDarkenSave( ob:cParentWnd,,,2)      ,;
                                  MsgDebug("ENTER - Your choice =",nStaticReturn) ,;
                                  FormDarkenRestore( aDim, 2 )     })

   oBrw:UserKeys(VK_F9, {|ob| nStaticReturn := ob:nAt                          ,;
                                  _myTsbColor(ob, 1)                           ,;
                                  aDim := FormDarkenSave( ob:cParentWnd,,,1)   ,;
                                  MsgDebug("F9 - Your choice =",nStaticReturn) ,;
                                  FormDarkenRestore( aDim, 1 )                 ,;
                                  _myTsbColor(ob, 2)                           ,;
                                  ob:SetFocus()                    })

//   oBrw:UserKeys(VK_F4, {|ob| _myTsb(ob, 1) } )
//   oBrw:UserKeys(VK_F5, {|ob| _myTsb(ob, 2) } )
                          
   oBrw:nFreeze     := 1     //  
   oBrw:lLockFreeze := .T.   //      

   //     
   oBrw:ResetVScroll( .T. ) 
   oBrw:oHScroll:SetRange( 0, 0 ) 

   nWBrw := oBrw:GetAllColsWidth()    //    
   If oBrw:nLen > oBrw:nRowCount()    //  -   > -    
      nWBrw += GetVScrollBarWidth()   //        
   EndIf
   //? "width of all columns of the table=",nWBrw 
   //? oBrw:nRight - oBrw:nLeft

   oBrw:Display()     //      

   oBrw:SetNoHoles()  //     

   oBrw:GoPos( 2,1 )         //        

   DO EVENTS 

   RETURN Nil

////////////////////////////////////////////////////////////////////////////////////
STATIC FUNCTION _myTsbColor( obrw, n )
   WITH OBJECT (App.Cargo)
   If n == 1
      :_oBrw_Col_Clone := {}
      :_oBrw_hBrush    := oBrw:hBrush
      AEval(obrw:aColumns, {|oc| AAdd( :_oBrw_Col_Clone, oc:Clone() ) } )
   ElseIf ! empty( :_oBrw_Col_Clone )
      AEval(:_oBrw_Col_Clone, {|oc,nc| obrw:aColumns[ nc ] :=  oc:Clone() } )
      oBrw:hBrush := :_oBrw_hBrush

      oBrw:ResetVScroll( .T. )  
      oBrw:oVScroll:SetRange( 0, 0 )  
      oBrw:oHScroll:SetRange( 0, 0 )  
        
      oBrw:Refresh()  
    
      If ! oBrw:lNoHScroll .and. oBrw:oHScroll != Nil  
         oBrw:oHScroll:SetPos( oBrw:nCell )  
      EndIf  
    
      oBrw:ResetVScroll( .T. )  
      oBrw:oHScroll:SetRange( 0, 0 )  
   EndIf
   END WITH
RETURN Nil

////////////////////////////////////////////////////////////////////////////////////
STATIC FUNCTION TsbColor( oBrw, aHColor, aBColor, nHClr1, nHClr2 )
   DEFAULT aHColor := {255, 255, 255} , ;      //   
           aBColor := {174, 174, 174} , ;      //    
           nHClr2  := ToRGB( aHColor ), ;
           nHClr1  := ToRGB( { 51, 51, 51 } )

   WITH OBJECT oBrw  // oBrw  \
   
     :SetColor( { 1}, { { || CLR_BLACK                         } } ) // 1 ,                                  
     :SetColor( { 2}, { { || ToRGB(aBColor)                    } } ) // 2 ,                                    
     :Setcolor( { 3}, { CLR_YELLOW                               } ) // 3 ,    
     :SetColor( { 4}, { { || { nHClr1, nHClr2                } } } ) // 4 ,   
     :SetColor( { 5}, { { ||   CLR_WHITE                       } } ) // 5 ,  ,                  
     :SetColor( { 6}, { { || { CLR_HRED,0}                     } } ) // 6 ,                                            
     :SetColor( { 7}, { { ||   CLR_RED                         } } ) // 7 ,                               
     :SetColor( { 8}, { { ||   CLR_YELLOW                      } } ) // 8 ,                                 
     :SetColor( { 9}, { CLR_WHITE                              } ) // 9 ,                                   
     :SetColor( {10}, { { || { nHClr1, nHClr2                } } } ) // 10,                                     
     :SetColor( {11}, { { ||   CLR_GRAY                        } } ) // 11,    (selected cell no focused)
     :SetColor( {12}, { { || { RGB(255,255,74), RGB(240,240,0)}} } ) // 12,    (selected cell no focused)   
     :SetColor( {13}, { { ||   CLR_HRED                        } } ) // 13,    
     :SetColor( {14}, { { || { nHClr1, nHClr2                } } } ) // 14,      
     :SetColor( {15}, { { ||   CLR_WHITE                       } } ) // 15,     
     :SetColor( {16}, { { || { CLR_BLACK, CLR_GRAY           } } } ) // 16,                                    
     :SetColor( {17}, { { ||   CLR_YELLOW                      } } ) // 17,  
     
     // ---- c      ----( oCol:nClrBack = oBrw:SetColor( {2} ...) ----
     AEval(:aColumns, {|oCol| oCol:nClrBack := { |nr,nc,ob| TsbColorBack(nr,nc,ob) } } )
     AEval(:aColumns, {|oCol| oCol:nClrFore := { |nr,nc,ob| TsbColorFore(nr,nc,ob) } } )

   END WITH  // oBrw  

   RETURN Nil
   
////////////////////////////////////////////////////////////////////////////////////
STATIC FUNCTION TsbColorBack( nAt, nCol, oBrw )
   LOCAL nTsbColor := oBrw:Cargo  // current color from oBrw:Cargo
   //        (   )
   LOCAL nClr3  := TsbGet(oBrw, "Name_1" )
   LOCAL nColor

   IF     nTsbColor == 1   // the default color of the table
         nColor := CLR_WHITE
   ELSEIF nTsbColor == 2   // color table gray
      nColor := CLR_HGRAY
   ELSEIF nTsbColor == 3   // color of the table "ruler"
      IF nAt % 2 == 0
         nColor := CLR_HGRAY
      ELSE
         nColor := ToRGB( aStaticBrwBackColor )  // CLR_WHITE
      ENDIF
   ELSEIF nTsbColor == 4    // the color of the table "columns"
      IF nCol % 2 == 0
         nColor := CLR_HGRAY
      ELSE
         nColor := CLR_WHITE
      ENDIF
   ELSEIF nTsbColor == 5    // the color of the table "chess"
      IF nAt % 2 == 0
         If nCol % 2 == 0; nColor := CLR_HGRAY
         Else            ; nColor := CLR_WHITE
         EndIf
      ELSE
         If nCol % 2 == 0; nColor := CLR_WHITE
         Else            ; nColor := CLR_HGRAY
         EndIf
      ENDIF
   ELSEIF nTsbColor == 6    // custom colors
   ENDIF
   //    
   //IF nSumma == 1500
   //   nColor := RGB(255,128,64) // ORANGE
   //ENDIF
   // IF nCol == 2  //   2-   
   //    nColor := CLR_WHITE
   // ENDIF

   RETURN nColor

////////////////////////////////////////////////////////////////////////////////////
STATIC FUNCTION TsbColorFore( nAt, nCol, oBrw )
   LOCAL nColor, nTsbColor := TsbGet(oBrw, "Name_9")
   Default nAt := 0 , nCol := 0

   nTsbColor := 1

   IF nTsbColor <= -100    
      nColor := CLR_HRED
   ELSEIF nTsbColor < 0         
      nColor := CLR_RED
   ELSE 
      nColor := CLR_BLACK
   ENDIF

   RETURN nColor

////////////////////////////////////////////////////////////////////////////////////
STATIC FUNCTION TsbGet( oBrw, xCol )
RETURN Eval( oBrw:GetColumn(xCol):bData )
   
////////////////////////////////////////////////////////////////////////////////////
//STATIC FUNCTION TsbPut( oBrw, xCol, xVal )
//RETURN Eval( oBrw:GetColumn(xCol):bData, xVal )

////////////////////////////////////////////////////////////////////
FUNCTION ToRGB(aDim)
   RETURN RGB(aDim[1],aDim[2],aDim[3])

///////////////////////////////////////////////////////////////////
FUNCTION n2RGB(nColor)
   LOCAL nR := 0, nG := 0, nB := 0, cColor := NTOC(nColor, 16)
   nR := CTON(SUBSTR( cColor, 5, 2 ), 16)
   nG := CTON(SUBSTR( cColor, 3, 2 ), 16)
   nB := CTON(SUBSTR( cColor, 1, 2 ), 16)
   RETURN {nR, nG, nB }

