/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2019 Verchenko Andrey <verchenkoag@gmail.com>
 * Copyright 2019 Sergej Kiselev <bilance@bilance.lv>
 * Copyright 2016 Grigory Filatov <gfilatov@inbox.ru>
*/
#define _HMG_OUTLOG
 
#include "hmg.ch"
#include "TSBrowse.ch"

////////////////////////////////////////////////////////////////////////////////////
FUNCTION FormDarkenSave( cFormName, aBackColor, aFontColor, nMode )
LOCAL nI, aFormBColor, aCtrls, cCtrlName, cCtrlType, aRetVal := {}
LOCAL a2BackColor, a2FontColor, lVal, oBrw, cObjLbl, nR, nC, nW, nH, aTsb2Color
DEFAULT cFormName := ThisWindow.Name , aBackColor := {42,42,42} //GRAY
DEFAULT aFontColor := SILVER ,  nMode := 0

? "------- save ---------"
    aFormBColor := GetProperty( cFormName, "BACKCOLOR" ) 
    AADD( aRetVal, { cFormName, "FORMA", "", "BACKCOLOR", aFormBColor } )
    SetProperty( cFormName, "BACKCOLOR", aBackColor ) 
? 0, PADR('',10,"_"), PADR("FORMA",10,"_"), PADR("BACKCOLOR",19,"_"), HB_ValToExp(aBackColor)
    aCtrls := _GetArrayOfAllControlsForForm( cFormName ) 
    FOR nI := 1 TO Len( aCtrls ) 
       cCtrlName := aCTrls[ nI ] 
       cCtrlType := GetControlType ( cCtrlName, cFormName ) 
       ? nI, PADR(cCtrlName,10,"_"), PADR(cCtrlType,10,"_")
       a2BackColor := GetProperty( cFormName, cCtrlName, "BACKCOLOR" ) 
       a2FontColor := GetProperty( cFormName, cCtrlName, "FONTCOLOR" ) 
       IF cCtrlType == "LABEL" .OR. cCtrlType == "LIST" .OR. cCtrlType == "COMBO" .OR. ;
          cCtrlType == "TEXT" .OR. cCtrlType == "RADIOGROUP" 
          AADD( aRetVal, { cFormName, cCtrlType, cCtrlName, "BACKCOLOR", a2BackColor } )
          AADD( aRetVal, { cFormName, cCtrlType, cCtrlName, "FONTCOLOR", a2FontColor } )
          SetProperty( cFormName, cCtrlName, "BACKCOLOR", aBackColor ) 
          SetProperty( cFormName, cCtrlName, "FONTCOLOR", aFontColor ) 
          ?? "BackColor/FontColor",HB_ValToExp(a2BackColor), HB_ValToExp(a2FontColor)

       ELSEIF cCtrlType == "CHECKBOX"
          AADD( aRetVal, { cFormName, cCtrlType, cCtrlName, "BACKCOLOR", a2BackColor } )
          AADD( aRetVal, { cFormName, cCtrlType, cCtrlName, "FONTCOLOR", a2FontColor } )
          SetProperty( cFormName, cCtrlName, "BACKCOLOR", aBackColor ) 
          SetProperty( cFormName, cCtrlName, "FONTCOLOR", YELLOW ) 
          ?? "BackColor/FontColor",HB_ValToExp(a2BackColor), HB_ValToExp(a2FontColor)

       ELSEIF cCtrlType == "FRAME"
          lVal := GetProperty( cFormName, cCtrlName, "Visible" )   
          SetProperty( cFormName, cCtrlName, "Visible", .F. )      //  
          AADD( aRetVal, { cFormName, cCtrlType, cCtrlName, "Visible", lVal } )
          ?? PADR("Visible",19,"_") , .F.

       ELSEIF cCtrlType == "OBUTTON" 
          lVal := GetProperty( cFormName, cCtrlName, "Enabled" )     
          AADD( aRetVal, { cFormName, cCtrlType, cCtrlName, "Enabled", lVal } )
          SetProperty( cFormName, cCtrlName, "Enabled", .F. )      // ஢ 
          ?? PADR("Enabled",19,"_") , .F.

       ELSEIF cCtrlType == "GETBOX" 
          DoMethod( cFormName, cCtrlName, 'Hide')
          AADD( aRetVal, { cFormName, cCtrlType, cCtrlName, "Hide", "" } )  
          ?? PADR("Hide",19,"_")  

       ELSEIF cCtrlType == "IMAGE" 
          lVal := GetProperty( cFormName, cCtrlName, "Visible" )   
          nR   := GetProperty( cFormName, cCtrlName, "Row"    ) 
          nC   := GetProperty( cFormName, cCtrlName, "Col"    ) 
          nW   := GetProperty( cFormName, cCtrlName, "Width"  ) 
          nH   := GetProperty( cFormName, cCtrlName, "Height" ) 

          SetProperty( cFormName, cCtrlName, "Visible", .F. )      //  

          //  ᥢ-⮢ / make a pseudo-edging
          cObjLbl := 'LblImg' + AllTRim( Str( _GetId() ) )
          @ nR, nC LABEL &cObjLbl PARENT &cFormName VALUE '' ;
            WIDTH nW HEIGHT nH  BACKCOLOR aBackColor BORDER CLIENTEDGE 
          AADD( aRetVal, { cFormName, "LABEL"  , cObjLbl, "DELETE", "" } )       //  浪 1

          SetProperty( cFormName, cCtrlName, "Visible", .F. )      //  
          AADD( aRetVal, { cFormName, cCtrlType, cCtrlName, "Visible", lVal } )  //  浪 2
          ?? PADR("Visible",19,"_") , .F. , "+ pseudo-edging"

          // ९ LABEL  ଥ  ࠢ쭮  梥
          // re-show LABEL on the form to display the color correctly
          This.&(cObjLbl).Hide
          DO EVENTS
          This.&(cObjLbl).Show
          DO EVENTS
          
       ELSEIF cCtrlType == "TBROWSE"
          oBrw := TsbObj( cCtrlName, cFormName )
          IF nMode == 0
             oBrw:Hide()
             nR   := GetProperty( cFormName, cCtrlName, "Row"    ) 
             nC   := GetProperty( cFormName, cCtrlName, "Col"    ) 
             nW   := GetProperty( cFormName, cCtrlName, "Width"  ) 
             nH   := GetProperty( cFormName, cCtrlName, "Height" ) 

             //  ᥢ-⮢ / make a pseudo-edging
             cObjLbl := 'LbloBrw' + AllTRim( Str( _GetId() ) )
             @ nR, nC LABEL &cObjLbl  PARENT &cFormName VALUE '' ;
               WIDTH nW HEIGHT nH  BACKCOLOR aBackColor BORDER CLIENTEDGE 
             AADD( aRetVal, { cFormName, "LABEL", cObjLbl, "DELETE", "" } )

             // ९ LABEL  ଥ  ࠢ쭮  梥
             // re-show LABEL on the form to display the color correctly
             This.&(cObjLbl).Hide
             DO EVENTS
             This.&(cObjLbl).Show
             DO EVENTS

             // ⨭  ⢥ ਬ / example picture
             cObjLbl := 'STOPIMG' + AllTRim( Str( _GetId() ) )
             @ nR + 5, nC + 5 IMAGE &cObjLbl  PARENT &cFormName    ;
               PICTURE 'ERRLOGO' WIDTH nW - 10 HEIGHT nH - 10 ;
               STRETCH TRANSPARENT BACKGROUNDCOLOR aBackColor
             AADD( aRetVal, { cFormName, "IMAGE", cObjLbl, "DELETE", "" } )

             AADD( aRetVal, { cFormName, cCtrlType, cCtrlName, "oBrw:Hide()", "" } )
             ?? PADR("oBrw:Hide()",19,"_") , "+ pseudo-edging"
          ELSEIF nMode == 1
             // ய ࠡ⪨ "TBROWSE"
          ELSE
             //  ⥪騥 梥 tsbrowse     aBackColor/aFontColor
             aTsb2Color := TsbColorSaveRepl(oBrw, aBackColor, aFontColor)
             //  ⥪騥 梥 tsbrowse  Cargo-ꥪ
             SetProperty( cFormName, cCtrlName, "Cargo", aTsb2Color )     

             AADD( aRetVal, { cFormName, cCtrlType, cCtrlName, "oBrw:Color", "" } )
             ?? PADR("oBrw:Color",19,"_") , aTsb2Color[1], aTsb2Color[2]
          ENDIF 
       ENDIF
       DoMethod(cFormName, cCtrlName, 'SetFocus')
    NEXT 

    //   ⨭  ଥ 
    FOR EACH nI IN aRetVal
        If nI[2] == 'IMAGE' .and. 'STOPIMG' $ nI[3]
           DoMethod(nI[1], nI[3], 'Hide')
           DO EVENTS
           DoMethod(nI[1], nI[3], 'Show')
           DO EVENTS
        EndIf
    NEXT
? '.'
RETURN aRetVal
   
////////////////////////////////////////////////////////////////////////////////////
FUNCTION FormDarkenRestore( aVal, nMode )     
LOCAL nI, cFormName, cCtrlName, cCtrlType, cPropName, xVal, oBrw, aTsb2Color
DEFAULT aVal := {} , nMode := 0

  IF LEN(aVal) == 0 
     MsgDebug("Error ! Not Dim aVal =", aVal)
  ELSE
? "------- restore ---------"
    FOR nI := 1 TO LEN( aVal ) 
       cFormName := aVal[ nI,1 ]
       cCtrlType := aVal[ nI,2 ] 
       cCtrlName := aVal[ nI,3 ] 
       cPropName := aVal[ nI,4 ] 
       xVal      := aVal[ nI,5 ] 
       ? nI, PADR(cCtrlName,10,"_"), PADR(cCtrlType,10,"_"), PADR(cPropName,19,"_")
       IF !_IsWindowDefined( cFormName ) 
          MsgDebug("Error ! Not FormName =",cFormName,", nI=",nI)
       ELSE
          IF cCtrlType == "FORMA"
             SetProperty( cFormName, cPropName, xVal ) 
             ?? HB_ValToExp(xVal)
          ELSE
             IF GetControlIndex(cCtrlName, cFormName ) > 0
                IF UPPER(cPropName) == "DELETE"
                   DoMethod(cFormName, cCtrlName, 'Release')
                   ?? "Release!"
                ELSE
                   IF cCtrlType == "LABEL" .OR. cCtrlType == "LIST" .OR.     ;
                      cCtrlType == "CHECKBOX" .OR. cCtrlType == "COMBO" .OR. ;
                      cCtrlType == "TEXT" .OR. cCtrlType == "RADIOGROUP"
                      SetProperty( cFormName, cCtrlName, cPropName, xVal ) 
                      ?? HB_ValToExp(xVal)
                   ELSEIF cCtrlType == "IMAGE" .OR. cCtrlType == "FRAME"
                      SetProperty( cFormName, cCtrlName, "Visible", xVal ) //  
                      ?? xVal
                   ELSEIF cCtrlType == "GETBOX"
                      DoMethod(cFormName, cCtrlName, 'Show')
                      ?? 'Show'
                   ELSEIF cCtrlType == "OBUTTON"   
                      SetProperty( cFormName, cCtrlName, "Enabled", xVal )   // ࠧ㥬 
                      ?? xVal
                   ELSEIF cCtrlType == "TBROWSE"
                      oBrw := TsbObj( cCtrlName, cFormName )
                      IF nMode == 0
                         oBrw:Show()
                         ?? "oBrw:Show()"
                      ELSEIF nMode == 1
                         // ய ࠡ⪨ "TBROWSE"
                      ELSE
                        //  ⥪騥 梥 tsbrowse  Cargo-ꥪ
                        aTsb2Color := GetProperty( cFormName, cCtrlName, "Cargo" )     
                        ?? "oBrw:Color", aTsb2Color[1], aTsb2Color[2]
                        // ⠭ 梥
                        TsbColorRestore(oBrw, aTsb2Color)
                      ENDIF 
                   ENDIF
                   DoMethod(cFormName, cCtrlName, 'SetFocus')
                ENDIF  // UPPER(cPropName) == "DELETE"
             ENDIF  // GetControlIndex(cCtrlName, cFormName ) > 0

          ENDIF  // cCtrlType == "FORMA"

       ENDIF  // !_IsWindowDefined( cFormName )
    NEXT

    DO EVENTS

  ENDIF
? '.'
RETURN Nil


////////////////////////////////////////////////////////////////////////////////////
Function TsbObj( ControlName, ParentForm )  
Local oBrw, i 
 
Default ParentForm := _HMG_ThisFormName 

If ( i := GetControlIndex(ControlName, ParentForm) ) > 0 
   oBrw:= _HMG_aControlIds [ i ] 
EndIf 
 
Return oBrw 
 
///////////////////////////////////////////////////////////////////
// Function: ࠭ ⥪騩 梥 TBROWSE  ᨢ
FUNCTION TsbColorSaveRepl(oBrw, aBackColor, aFontColor)
   LOCAL nI, nJ, oCol, aColor, aTsbColor := {}
   LOCAL nBackColor, nFontColor, nTsbBrsh

   For nI := 1 To oBrw:nColCount() // 1,2,3.... 
      oCol := oBrw:aColumns[ nI ]
      oCol:SaveColor()
      aColor := oCol:aColorsBack
//? "=====", nI, aColor, HB_ValToExp(aColor)
      AADD( aTsbColor, aColor )
   Next

   nFontColor := ToRGB( aFontColor )
   nBackColor := ToRGB( aBackColor )
   // ------  梥 Tsbrowse ------------
   FOR nJ := 1 to LEN(oBrw:aColumns)  // 塞 梥  ᥬ 
      oBrw:SetColor( { 1}, { { || nFontColor } } )  // 1 , ⥪  祩 ⠡
      oBrw:SetColor( { 2}, { { || nBackColor } } )  // 2 , 䮭  祩 ⠡  
      oBrw:Setcolor( { 3}, { CLR_WHITE         } )  // 3 , ⥪ 蠯 ⠡ 
      oBrw:SetColor( { 4}, { { || nBackColor } } )  // 4 , 䮭 蠯 ⠡
      oBrw:SetColor( { 9}, { CLR_WHITE         } )  // 9 , ⥪  ⠡                                
      oBrw:SetColor( {10}, { { || nBackColor } } )  // 10, 䮭  ⠡                                  
   NEXT
   nTsbBrsh := oBrw:hBrush
   oBrw:hBrush := CreateSolidBrush( aBackColor[1], aBackColor[2], aBackColor[3] )  // 梥 䮭  ⠡楩

//? "LEN=", aTsbColor, nTsbBrsh

RETURN { aTsbColor, nTsbBrsh }

///////////////////////////////////////////////////////////////////
// Function: ⠭ 梥 TBROWSE  ᨢ
FUNCTION TsbColorRestore(oBrw, aTsb2Color)
   LOCAL nI, oCol, nTsbBrsh, aColor

   // ------ ⠭ 梥 Tsbrowse ------------
   For nI := 1 To oBrw:nColCount() // 1,2,3.... 
      oCol := oBrw:aColumns[ nI ]
      oCol:RestColor()
   Next

   nTsbBrsh    := aTsb2Color[2]
   aColor      := n2RGB(nTsbBrsh)
   oBrw:hBrush := CreateSolidBrush( aColor[1], aColor[2], aColor[3] )

   oBrw:ResetVScroll( .T. )  
   oBrw:oVScroll:SetRange( 0, 0 )  
   oBrw:oHScroll:SetRange( 0, 0 )  
     
   oBrw:Refresh()  
   
   If ! oBrw:lNoHScroll .and. oBrw:oHScroll != Nil  
      oBrw:oHScroll:SetPos( oBrw:nCell )  
   EndIf  
   
   oBrw:ResetVScroll( .T. )  
   oBrw:oHScroll:SetRange( 0, 0 )  

RETURN NIL


////////////////////////////////////////////////////////////////////////////////////
Procedure ChangeAllBackcolor 
LOCAL i, nFormCount := Len( _HMG_aFormNames ) 
LOCAL nI, cCtrlName, cFormName 
LOCAL aCtrls 
 
   FOR i := 1 TO nFormCount 
      cFormName := _HMG_aFormNames [ i ] 
      IF _IsWindowDefined ( cFormName ) 
         SetProperty( cFormName, "BACKCOLOR", GRAY ) 
         aCtrls := _GetArrayOfAllControlsForForm( cFormName ) 
         FOR nI := 1 TO Len( aCtrls ) 
            cCtrlName := aCTrls[ nI ] 
            SetProperty( cFormName, cCtrlName, "BACKCOLOR", GRAY ) 
            SetProperty( cFormName, cCtrlName, "FONTCOLOR", WHITE ) 
        NEXT 
      ENDIF 
   NEXT 
 
Return 
  
////////////////////////////////////////////////////////////////////////////////////
FUNCTION _GetArrayOfAllControlsForForm ( cFormName ) 
LOCAL nFormHandle, i, nControlCount, aRetVal := {}, x 
 
nFormHandle := GetFormHandle ( cFormName ) 
nControlCount := Len ( _HMG_aControlHandles ) 
FOR i := 1 TO nControlCount 
   IF _HMG_aControlParentHandles[ i ] == nFormHandle 
      IF ValType( _HMG_aControlHandles[ i ] ) == 'N' 
         IF ! Empty( _HMG_aControlNames[ i ] ) 
            IF AScan( aRetVal, _HMG_aControlNames[ i ] ) == 0 
               AAdd( aRetVal, _HMG_aControlNames[ i ] ) 
            ENDIF 
         ENDIF 
      ELSEIF ValType( _HMG_aControlHandles[i ] ) == 'A' 
         FOR x := 1 TO Len ( _HMG_aControlHandles[ i ] ) 
            IF !Empty( _HMG_aControlNames[ i ] ) 
               IF AScan( aRetVal, _HMG_aControlNames[ i ] ) == 0 
                  AAdd( aRetVal, _HMG_aControlNames[ i ] ) 
               ENDIF 
            ENDIF 
         NEXT x 
      ENDIF 
   ENDIF 
NEXT i 
 
RETURN ASort( aRetVal )
